//+------------------------------------------------------------------+
//|                                          Partial order close.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//|                                                                  |
//| Source codes:                                                    |
//| http://www.iexpertadvisor.com/MetaTrader-Forex-Training-Course/partial-close.html
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

// these are all externs so they can be changed when the EA is attached to a chart
// the values set are default values

extern int instanceID = 5;
extern int TicketNumber = 12345678;
extern string note1 = "--------------------------------------------";
extern string note2 = "Closing Criteria: 1 = Lot size ; 2 = Percentage";
extern int ClosingCriteria = 1;
extern string note3 = "Target Criteria: 1 = Price ; 2 = PIPs";
extern int TargetCriteria = 1;
extern string note4 = "--------------------------------------------";
extern int TargetLevel_1 = 10;  //profit_level_1
extern double ClosingSize_1 = 5;   //lot_size_2
extern double Move_SL_1 = 5;
extern int TargetLevel_2 = 25;     
extern double ClosingSize_2 = 2; 
extern double Move_SL_2 = 5;
extern int TargetLevel_3 = 25;     
extern double ClosingSize_3 = 2; 
extern double Move_SL_3 = 5;
extern int TargetLevel_4 = 25;     
extern double ClosingSize_4 = 2; 
extern double Move_SL_4 = 5;

int   TargetLevel = 0;

int start()
{
   //check if Target Criteria (1 = Price ; 2 = PIPs) has been met, either for OrderType=OP_BUY or OrderType=OP_SELL
   fnCheckTargetCriteria();
   
   if ( TargetLevel > 0)
      fnPartialClose();
   return(0);   
}

//=======================================================

// This function returns true to indicate Target Criteria has been met, so partial closure should happen
bool fnCheckTargetCriteria()
{
   double   priceBID;     //price should be Bid (selling price) to close a Buy order
   double   priceASK;     //price should be Ask (buying price) to close Sell order
   int      pips;          // amount of PIPs from open price
   
   priceBID=MarketInfo(Symbol(),MODE_BID);
   priceASK=MarketInfo(Symbol(),MODE_ASK);
   
   if(OrderSelect(TicketNumber, SELECT_BY_TICKET)==true)
   {
      if (OrderType()==OP_BUY)
      {
         if (TargetCriteria == 1)  //Target Criteria: 1 = Price
         {
            if (priceBID >= TargetLevel_1 && TargetLevel == 0)
               TargetLevel = 1;  //means TG1 has been reached
            if (priceBID >= TargetLevel_2 && TargetLevel == 1)
               TargetLevel = 2;  //means TG1 has been reached
            if (priceBID >= TargetLevel_3 && TargetLevel == 2)
               TargetLevel = 3;  //means TG1 has been reached
            if (priceBID >= TargetLevel_4 && TargetLevel == 4)
               TargetLevel = 4;  //means TG1 has been reached
         }
         else  //Target Criteria: 2 = PIPs
         {
            pips = (priceBID - OrderOpenPrice())/Point;
            
            if (pips >= TargetLevel_1 && TargetLevel == 0)
               TargetLevel = 1;  //means TG1 has been reached
            if (pips >= TargetLevel_2 && TargetLevel == 1)
               TargetLevel = 2;  //means TG1 has been reached
            if (pips >= TargetLevel_3 && TargetLevel == 2)
               TargetLevel = 3;  //means TG1 has been reached
            if (pips >= TargetLevel_4 && TargetLevel == 4)
               TargetLevel = 4;  //means TG1 has been reached
         }
      }
      else     //OrderType()==OP_SELL
      {
         if (TargetCriteria == 1)  //Target Criteria: 1 = Price
         {
            if (priceASK <= TargetLevel_1 && TargetLevel == 0)
               TargetLevel = 1;  //means TG1 has been reached
            if (priceASK <= TargetLevel_2 && TargetLevel == 1)
               TargetLevel = 2;  //means TG1 has been reached
            if (priceASK <= TargetLevel_3 && TargetLevel == 2)
               TargetLevel = 3;  //means TG1 has been reached
            if (priceASK <= TargetLevel_4 && TargetLevel == 3)
               TargetLevel = 4;  //means TG1 has been reached
         }
         else  //Target Criteria: 2 = PIPs
         {
            pips = (OrderOpenPrice() - priceASK)/Point;
            
            if (pips >= TargetLevel_1 && TargetLevel == 0)
               TargetLevel = 1;  //means TG1 has been reached
            if (pips >= TargetLevel_2 && TargetLevel == 1)
               TargetLevel = 2;  //means TG1 has been reached
            if (pips >= TargetLevel_3 && TargetLevel == 3)
               TargetLevel = 3;  //means TG1 has been reached
            if (pips >= TargetLevel_4 && TargetLevel == 4)
               TargetLevel = 4;  //means TG1 has been reached
         }
      }
   }
   else
      Print("OrderSelect returned the error of ",GetLastError());
}
   
void fnPartialClose()
{
   double close_lot_size=0;
   
         if( OrderType() == OP_BUY )
         {
            switch (TargetLevel)
            {
               case '1':
               if (ClosingCriteria == 1) //Closing Criteria: 1 = Lot size ; 2 = Percentage
               {
                  OrderClose(OrderTicket(), ClosingSize_1, Bid, 3, Blue);
               }
               else  //Closing Criteria: 2 = Percentage
               {
//                  if( OrderLots() > ClosingSize_1 )
//                  {
                     close_lot_size = fnFormatLot(OrderLots() - ClosingSize_1);
                     OrderClose(OrderTicket(), close_lot_size, Bid, 3, Blue);
                     return;
//                  }
               }
               break;
               
               case '2':
               if (ClosingCriteria == 1) //Closing Criteria: 1 = Lot size ; 2 = Percentage
               {
                  OrderClose(OrderTicket(), ClosingSize_2, Bid, 3, Blue);
               }
               else  //Closing Criteria: 2 = Percentage
               {
//                  if( OrderLots() > ClosingSize_2 )
//                  {
                     close_lot_size = fnFormatLot(OrderLots() - ClosingSize_2);
                     OrderClose(OrderTicket(), close_lot_size, Bid, 3, Blue);
                     return;
//                  }
               }
               break;
               
               case '3':
               if (ClosingCriteria == 1) //Closing Criteria: 1 = Lot size ; 2 = Percentage
               {
                  OrderClose(OrderTicket(), ClosingSize_3, Bid, 3, Blue);
               }
               else  //Closing Criteria: 2 = Percentage
               {
//                  if( OrderLots() > ClosingSize_3 )
//                  {
                     close_lot_size = fnFormatLot(OrderLots() - ClosingSize_3);
                     OrderClose(OrderTicket(), close_lot_size, Bid, 3, Blue);
                     return;
//                  }
               }
               break;
               
               case '4':
               if (ClosingCriteria == 1) //Closing Criteria: 1 = Lot size ; 2 = Percentage
               {
                  OrderClose(OrderTicket(), ClosingSize_4, Bid, 3, Blue);
               }
               else  //Closing Criteria: 2 = Percentage
               {
//                  if( OrderLots() > ClosingSize_4 )
//                  {
                     close_lot_size = fnFormatLot(OrderLots() - ClosingSize_4);
                     OrderClose(OrderTicket(), close_lot_size, Bid, 3, Blue);
                     return;
//                  }
               }
               break;  
            }
         }
         else     //OrderType() == OP_SELL
         {
            switch (TargetLevel)
            {
               case '1':
               if (ClosingCriteria == 1) //Closing Criteria: 1 = Lot size ; 2 = Percentage
               {
                  OrderClose(OrderTicket(), ClosingSize_1, Ask, 3, Blue);
               }
               else  //Closing Criteria: 2 = Percentage
               {
//                  if( OrderLots() > ClosingSize_1 )
//                  {
                     close_lot_size = fnFormatLot(OrderLots() - ClosingSize_1);
                     OrderClose(OrderTicket(), close_lot_size, Ask, 3, Blue);
                     return;
//                  }
               }
               break;
               
               case '2':
               if (ClosingCriteria == 1) //Closing Criteria: 1 = Lot size ; 2 = Percentage
               {
                  OrderClose(OrderTicket(), ClosingSize_2, Ask, 3, Blue);
               }
               else  //Closing Criteria: 2 = Percentage
               {
//                  if( OrderLots() > ClosingSize_2 )
//                  {
                     close_lot_size = fnFormatLot(OrderLots() - ClosingSize_2);
                     OrderClose(OrderTicket(), close_lot_size, Ask, 3, Blue);
                     return;
//                  }
               }
               break;
               
               case '3':
               if (ClosingCriteria == 1) //Closing Criteria: 1 = Lot size ; 2 = Percentage
               {
                  OrderClose(OrderTicket(), ClosingSize_3, Ask, 3, Blue);
               }
               else  //Closing Criteria: 2 = Percentage
               {
//                  if( OrderLots() > ClosingSize_3 )
//                  {
                     close_lot_size = fnFormatLot(OrderLots() - ClosingSize_3);
                     OrderClose(OrderTicket(), close_lot_size, Ask, 3, Blue);
                     return;
//                  }
               }
               break;
               
               case '4':
               if (ClosingCriteria == 1) //Closing Criteria: 1 = Lot size ; 2 = Percentage
               {
                  OrderClose(OrderTicket(), ClosingSize_4, Ask, 3, Blue);
               }
               else  //Closing Criteria: 2 = Percentage
               {
//                  if( OrderLots() > ClosingSize_4 )
//                  {
                     close_lot_size = fnFormatLot(OrderLots() - ClosingSize_4);
                     OrderClose(OrderTicket(), close_lot_size, Ask, 3, Blue);
                     return;
//                  }
               }
               break;  
            }

/*/ check each level
            if( ((Bid - OrderOpenPrice()) * Point) > profit_level_1 )
            {
               if( OrderLots() > lot_size_1 )
               {
                  close_lot_size = fnFormatLot(OrderLots() - lot_size_1);
                  OrderClose(OrderTicket(), close_lot_size, Bid, 3, Blue);
                  return;
               }
            }
            
            // check each level
            if( ((Bid - OrderOpenPrice()) * Point) > profit_level_2 )
            {
               if( OrderLots() > lot_size_2 )
               {
                  close_lot_size = fnFormatLot(OrderLots() - lot_size_2);
                  OrderClose(OrderTicket(), close_lot_size, Bid, 3, Blue);
                  return;
               }
            }
         }
         
         if( OrderType() == OP_SELL )
         {
            // check each level
            if( ((OrderOpenPrice() - Ask) * Point) > profit_level_1 )
            {
               if( OrderLots() > lot_size_1 )
               {
                  close_lot_size = fnFormatLot(OrderLots() - lot_size_1);
                  OrderClose(OrderTicket(), close_lot_size, Ask, 3, Blue);
                  return;
               }
            }
            
            // check each level
            if( ((OrderOpenPrice() - Ask) * Point) > profit_level_2 )
            {
               if( OrderLots() > lot_size_2 )
               {
                  close_lot_size = fnFormatLot(OrderLots() - lot_size_2);
                  OrderClose(OrderTicket(), close_lot_size, Ask, 3, Blue);
                  return;
               }
            }
         }
      
      }*/
      
    }

}

double fnFormatLot(double dLots)
{
   double min, max, step, lots;
   int lotdigits=1;
      
   step = MarketInfo(Symbol(), MODE_LOTSTEP);
   
   if( step == 0.01 )
      lotdigits=2;
      
   if( step == 0.1 )
      lotdigits=1;
   
   lots = StrToDouble(DoubleToStr(dLots, lotdigits));
   
   min = MarketInfo(Symbol(), MODE_MINLOT);
   if( lots < min )
      return(min);
      
   max = MarketInfo(Symbol(), MODE_MAXLOT);
   if( lots > max )
      return(max);
 
   return(lots);
}

//+------------------------------------------------------------------+